pragma solidity 0;

contract incrementer {
	uint32 private value;
	event Foo(uint32);

	/// Constructor that initializes the `int32` value to the given `init_value`.
	constructor(uint32 initvalue) {
		value = initvalue;
	}

	/// This increments the value by `by`. 
	function inc(uint32 by) public returns (uint32) {
		value += by;
		emit Foo(value);

		return value;
	}

	/// Simply returns the current value of our `uint32`.
	function get() public view returns (uint32) {
		emit Foo(value);
		return value;
	}

	function fail() public pure returns (uint32) {
		revert("fail");
	}
}
